<template>
  <single-pane>
    <ob-func-panel
      :columns="[]"
      :showSort="false"
      :showGroup="false"
      :showColumnFilter="false"
      addButtonText="Добавить совместимые ЖД станции"
      :show-add-button="true"
      @add="onAdd"
      @search="onSearch"
    />
    <div class="comps">
      <div class="comps__header">
        <div class="comps__header-icon">
          <i class="icon chevron-up"></i>
        </div>
        <div class="comps__header-title">
          Наименование
        </div>
        <div class="comps__header-changed">
          Последние изменения
        </div>
        <div class="comps__header-author">
          Автор
        </div>
      </div>
      <div class="comps__content" v-if="items">
        <div class="comp__items" v-for="item in items" :key="item.uuid">
          <div class="comps__direction" @click="openDirection(item.uuid)">
            <div class="comps__direction-icon">
              <i class="icon chevron-down" v-if="!item.opened"></i>
              <i class="icon chevron-up" v-if="item.opened"></i>
            </div>
            <div class="comps__direction-title">
              <i class="icon" :class="$options.iconMap[item.from.geographyType]"></i>
              {{item.from.title}}
              <svg fill="none" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 16 16" width="16" height="16"><path d="M10.108 6.126c0-.28.325-.434.543-.258l2.459 1.985a.333.333 0 01-.002.52l-2.466 1.96a.333.333 0 01-.54-.262l.002-1.307h-6.67a.667.667 0 110-1.334h6.672l.002-1.304z" fill="#9DA0AC"/></svg>
              <i class="icon" :class="$options.iconMap[item.to.geographyType]"></i>
              {{item.to.title}}
            </div>
            <div class="comps__direction-changed">
              {{item.updatedAt | date}}
            </div>
            <div class="comps__direction-author">
              {{item.author.firstName}} {{item.author.lastName}}
            </div>
            <div class="comps__direction-qty">
              Станций: {{item.locationCount}}
            </div>
            <div class="comps__direction-action" @click.stop="onDeleteList(item)">
              <i class="icon close"></i>
            </div>
          </div>
          <expand-transition scrollIntoView>
            <div class="comp__locations" v-if="item.opened">
              <div class="comp__locations-from">
                <div class="comp__location" v-for="location in item.locationsFrom" :key="location.uuid">
                  <div class="comp__location-title">
                    <i class="icon train-sm"></i>
                    {{ location.title }}
                  </div>
                  <div class="comp__location-action">
                    <i class="icon close" v-if="item.locationsFrom.length > 1" @click="onDeleteLocation(item, location)"></i>
                  </div>
                </div>
              </div>
              <div class="comp__locations-to">
                <div class="comp__location" v-for="location in item.locationsTo" :key="location.uid">
                  <div class="comp__location-title">
                    <i class="icon train-sm"></i>
                    {{ location.title }}
                  </div>
                  <div class="comp__location-action">
                    <i class="icon close" v-if="item.locationsTo.length > 1" @click="onDeleteLocation(item, location)"></i>
                  </div>
                </div>
              </div>
              <div class="comp__locations-edit">
                <span @click="onEditList(item)">
                  <i class="icon edit"></i>
                  Редактировать список
                </span>
              </div>
            </div>
          </expand-transition>
        </div>
      </div>
    </div>
    <ob-modal
      ref="newDirectionModal"
      size="medium"
      title="Совместимые ЖД станции"
      :titleSecond='listToEdit ? "Изменение" : "Добавление"'
      @closed="resetNewDirectionModal"
    >
      <ob-form
        :formModel="formModel"
        :formData="formData"
        :isNew="!!listToEdit"
        @submit="onSubmitDirectionEdit"
      >
        <div class="comp-form">          
          <div class="comp-form__block">
            <h2 class="comp-form__block-title">Откуда</h2>
            <div class="comp-form__row">
              <ob-select
                v-model="formData.fromUuid"
                :remote-opt="{
                  method: getDirectionsList
                }"
                :initialValue="listToEdit? [{...listToEdit.from, icon: $options.iconMap[listToEdit.from.geographyType]}] : []"
                label="Агломерация или опорник"
                placeholder="Выберите из списка"
                required
                isAutoComplete
                :disabled="!isNewDirection"
                @selected="onDirectionSelected($event, 'from')"
              />
            </div>
            <div class="comp-form__row">
              <ob-select
                ref="fromLocations"
                v-model="formData.fromLocations"
                :remote-opt="{
                  method: getFromDirectionLocations
                }"
                :initialValue="listToEdit ? listToEdit.locationsFrom : []"
                isDropdown
                isAutoComplete
                label="Совместимые ЖД станции"
                placeholder="Выберите один или несколько вариантов"
                required
                :disabled="!formData.fromUuid"
              />
            </div>
          </div>
          <div class="comp-form__block">
            <h2 class="comp-form__block-title">Куда</h2>
            <div class="comp-form__row">
              <ob-select
                v-model="formData.toUuid"
                :remote-opt="{
                  method: getDirectionsList
                }"
                :initialValue="listToEdit? [{...listToEdit.to, icon: $options.iconMap[listToEdit.to.geographyType]}] : []"
                label="Агломерация или опорник"
                placeholder="Выберите из списка"
                required
                isAutoComplete
                :disabled="!isNewDirection"
                @selected="onDirectionSelected($event, 'to')"
              />
            </div>
            <div class="comp-form__row">
              <ob-select
                ref="toLocations"
                v-model="formData.toLocations"
                :remote-opt="{
                  method: getToDirectionLocations
                }"
                :initialValue="listToEdit ? listToEdit.locationsTo : []"
                isDropdown
                isAutoComplete
                label="Совместимые ЖД станции"
                placeholder="Выберите один или несколько вариантов"
                required
                :disabled="!formData.toUuid"
              />
            </div>
          </div>
        </div>
      </ob-form>
    </ob-modal>
    <ob-modal
      v-if="directionToDelete"
      ref="directionDeleteModal"
      size="medium"
      title="Удаление совместимых ЖД станций"
      ok-text="Удалить"
      is-error
      is-show-controls
      is-confirm
      @submit="onSubmitDirectionDelete"
    >
      <p class="direction-to-delete">
        Направление:
        <i class="icon" :class="$options.iconMap[directionToDelete.from.geographyType]"></i>
        {{directionToDelete.from.title}}
        <svg fill="none" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 16 16" width="16" height="16"><path d="M10.108 6.126c0-.28.325-.434.543-.258l2.459 1.985a.333.333 0 01-.002.52l-2.466 1.96a.333.333 0 01-.54-.262l.002-1.307h-6.67a.667.667 0 110-1.334h6.672l.002-1.304z" fill="#9DA0AC"/></svg>
        <i class="icon" :class="$options.iconMap[directionToDelete.to.geographyType]"></i>
        {{directionToDelete.to.title}}
      </p>
      <p>Станций: {{ directionToDelete.locationCount }} </p>
    </ob-modal>
    <ob-modal
      v-if="locationToDelete"
      ref="locationDeleteModal"
      size="medium"
      title="Удаление ЖД станции"
      ok-text="Удалить"
      is-error
      is-show-controls
      is-confirm
      @submit="onSubmitLocationDelete"
    >
      <p class="location-to-delete">
        Локация:
        <i class="icon train-sm"></i>
        {{ locationToDelete.title }}
      </p>
    </ob-modal>
  </single-pane>
</template>
<script>
import api from '@/api';
import { uuid } from "vue-uuid";
import { required } from 'vuelidate/lib/validators'
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import obFuncPanel from 'common-components/src/obComponents/obFuncPanel';
import obModal from 'common-components/src/obComponents/obModal';
import obForm from 'common-components/src/obComponents/obForm';
import expandTransition from '../../components/ExpandTransition';
import obSelect from 'common-components/src/obComponents/obSelect';

export default {
  name: 'DictionaryContainersCompatibility',
  iconMap: {
    'AGGLOMERATION': 'aglomeration',
    'REFERENCE_POSITION': 'city-sm'
  },

  components: {
    SinglePane,
    obFuncPanel,
    expandTransition,
    obModal,
    obForm,
    obSelect
  },

  data() {
    return {
      items: null,
      listToEdit: null,
      directionToDelete: null,
      locationToDelete: null,
      directions: [],
      locations: [],
      formModel: {
        fromUuid: {
          value: '',
          validator: {
            required
          }
        },
        fromGeographyType: {
          value: '',
          // validator: {
          //   required
          // }
        },
        toUuid: {
          value: '',
          validator: {
            required
          }
        },
        toGeographyType: {
          value: '',
          // validator: {
          //   required
          // }
        },
        fromLocations: {
          value: '',
          validator: {
            required
          }
        },
        toLocations: {
          value: '',
          validator: {
            required
          }
        }
      },
      formData: {
        fromUuid: '',
        fromGeographyType: '',
        toUuid: '',
        toGeographyType: '',
        fromLocations: [],
        toLocations: []
      }
    }
  },

  computed: {
    isNewDirection() {
      return !this.listToEdit;
    }
  },

  async created() {
    await this.getData();
  },

  methods: {
    async getData() {
      try {
        const data = await api.locations.getCompatibleLocations();
        const payload = data.map(item => {
          return { ...item, opened: false, locationsFrom: [], locationsTo: []};
        })
        this.items = payload;
      } catch (err) {
        console.error(err);
      }
    },

    async getDirectionsList({ page, size, query }) {
      try {
        const res = await api.locations.getDirectionsList({ page, size, query });
        res.content = res.content.map(item => {
          return { ...item, icon: this.$options.iconMap[item.geographyType] }
        });
        this.directions = res.content;
        return res;
      } catch (err) {
        console.error(err);
      }
    },

    async getFromDirectionLocations({ page, size, query }) {
      try {
        if (this.formData.fromUuid.length && this.formData.fromGeographyType.length) {
          const uuid = this.listToEdit?.from?.uuid || this.formData?.fromUuid;
          const type = this.listToEdit?.from?.geographyType || this.formData?.fromGeographyType;
          const res = await api.locations.getDirectionLocations(uuid, type, page, size, query);
          res.content = res.content.map(item => {
            return { ...item, icon: 'train-sm'}
          });
          return res;
        }
      } catch (err) {
        console.error(err);
      }
    },

    async getToDirectionLocations({ page, size, query }) {
      try {
        if (this.formData.toUuid.length && this.formData.toGeographyType.length) {
          const uuid = this.listToEdit?.to?.uuid || this.formData?.toUuid;
          const type = this.listToEdit?.to?.geographyType || this.formData?.toGeographyType;
          const res = await api.locations.getDirectionLocations(uuid, type, page, size, query);
          res.content = res.content.map(item => {
            return { ...item, icon: 'train-sm'}
          })
          return res;
        }
      } catch (err) {
        console.error(err);
      }
    },

    async openDirection(uuid) {
      const dir = this.items.find(item => item.uuid === uuid);
      if (dir.opened) {
        dir.opened = false;
        return;
      }
      if (dir.locationsFrom.length || dir.locationsTo.length) {
        dir.opened = true;
        return;
      }
      if (!dir.locationsFrom.length && !dir.locationsTo.length) {
        try {
          const data = await api.locations.getContainerRouteLocations(uuid);
          dir.locationsFrom = data.locationsFrom;
          dir.locationsTo = data.locationsTo;
          dir.opened = true;
        } catch (err) {
          console.error(err);
        }
      }
    },

    onAdd() {
      this.$refs.newDirectionModal.open();
    },

    async onEditList(item) {
      this.listToEdit = item;
      const fromUuid = this.listToEdit.from.uuid;
      const toUuid = this.listToEdit.to.uuid;
      this.formData = {
        fromUuid,
        fromGeographyType: this.listToEdit.from.geographyType,
        toUuid,
        toGeographyType: this.listToEdit.to.geographyType,
        fromLocations: this.listToEdit.locationsFrom.map(item => item.uuid),
        toLocations: this.listToEdit.locationsTo.map(item => item.uuid)
      };
      this.$refs.newDirectionModal.open();
      await this.$nextTick();
      if (!this.isNewDirection) {
        this.$refs.fromLocations.loadData();
        this.$refs.toLocations.loadData();
      }
    },

    onDirectionSelected(e, direction) {
      const directionsMap = {
        from: 'fromGeographyType',
        to: 'toGeographyType'
      }
      
      const locationsMap = {
        from: 'fromLocations',
        to: 'toLocations'
      }

      this.formData[directionsMap[direction]] = e.geographyType;

      this.$refs[locationsMap[direction]].loadData();
    },

    async onDeleteList(item) {
      this.directionToDelete = item;
      await this.$nextTick();
      this.$refs.directionDeleteModal.open();
    },

    async onSubmitDirectionDelete() {
      try {
        await api.locations.deleteDirection(this.directionToDelete.uuid);
        this.$refs.directionDeleteModal.close();
        this.directionToDelete = null;
        await this.getData();
      } catch (err) {
        console.error(err);
      }
    },

    async onDeleteLocation(item, location) {
      this.locationToDelete = { ...location, directoryUuid: item.uuid};
      await this.$nextTick();
      this.$refs.locationDeleteModal.open();
    },

    async onSubmitLocationDelete() {
      try {
        await api.locations.deleteDirectionLocation(this.locationToDelete.directoryUuid, this.locationToDelete.uuid);
        const dir = this.items.find(item => item.uuid === this.locationToDelete.directoryUuid);
        const data = await api.locations.getContainerRouteLocations(dir.uuid);
        dir.locationsFrom = data.locationsFrom;
        dir.locationsTo = data.locationsTo;
        dir.locationCount = data.locationsFrom.length + data.locationsTo.length;
        this.$refs.locationDeleteModal.close();
        this.locationToDelete = null;
      } catch (err) {
        console.error(err)
      }      
    },

    async onSubmitDirectionEdit() {
      try {
        if (this.isNewDirection) {
          const newUuid = uuid.v4();
          const payload = {
            from: {
              uuid: this.formData.fromUuid,
              geographyType: this.formData.fromGeographyType,
            },
            to: {
              uuid: this.formData.toUuid,
              geographyType: this.formData.toGeographyType
            }
          }
          const res = await api.locations.addNewDirection(newUuid, payload);
          if (res && res.status === 201) {
            const locations = {
              locationsFrom: this.formData.fromLocations.map(item => ({uuid: item})),
              locationsTo: this.formData.toLocations.map(item => ({uuid: item}))
            }
            await api.locations.addLocationsToDirection(newUuid, locations);
          }
        } else {
          const locations = {
            locationsFrom: this.formData.fromLocations.map(item => ({uuid: item})),
            locationsTo: this.formData.toLocations.map(item => ({uuid: item}))
          }
          await api.locations.addLocationsToDirection(this.listToEdit.uuid, locations);
          const dir = this.items.find(item => item.uuid === this.listToEdit.uuid);
          const data = await api.locations.getContainerRouteLocations(dir.uuid);
          dir.locationsFrom = data.locationsFrom;
          dir.locationsTo = data.locationsTo;
        }

        this.$refs.newDirectionModal.close();
        this.listToEdit = null;
        this.formData = {
          fromUuid: '',
          fromGeographyType: '',
          toUuid: '',
          toGeographyType: '',
          fromLocations: [],
          toLocations: []
        }
        if (this.isNewDirection) {
          await this.getData()
        }
      } catch (err) {
        console.error(err);
      }
    },

    resetNewDirectionModal() {
      this.listToEdit = null;
      this.formData = {
        fromUuid: '',
        fromGeographyType: '',
        toUuid: '',
        toGeographyType: '',
        fromLocations: [],
        toLocations: []
      }
    },

    onSearch($event) {
      console.log('search ->', $event);
    }
  }
}
</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.comps {
  overflow-y: auto;
}

.comps__header {
  padding: 15px 0;
  display: flex;
  align-items: center;
  font-size: 10px;
  color: $shale-gray;
  text-transform: uppercase;
}
.comps__header-icon {
  font-size: 16px;
  width: 36px;
  text-align: center;
}
.comps__header-title {
  width: 600px;
}
.comps__header-changed {
  width: 160px;
}
.comps__header-author {
  width: 250px;
}
.comps__content {
}
.comp__items {
  &:not(:last-child) {
    margin-bottom: 2px;
  }
}
.comps__direction {
  display: flex;
  padding: 20px 0;
  background-color: $blue-150;
  color: $color-blue-smalt;
  cursor: pointer;
}
.comps__direction-icon {
  font-size: 16px;
  width: 36px;
  text-align: center;
}
.comps__direction-title {
  width: 600px;
  display: flex;
  align-items: center;

  .icon {
    margin-right: 10px;
  }

  svg {
    margin: 0 10px;
  }
}
.comps__direction-changed {
  width: 160px;
}
.comps__direction-author {
  width: 250px;
}
.comps__direction-qty {
  width: 100px;
  color: $gray-slate;
}
.comps__direction-action {
  display: flex;
  align-items: center;
  font-size: 10px;
  width: 30px;
  color: $color-grey-span;
  cursor: pointer;
}
.comp__locations {
  display: flex;
  flex-wrap: wrap;
}
.comp__locations-from {
  width: 636px;
  padding-left: 36px;
  padding-right: 45px;
}
.comp__locations-to {
  width: 540px;
}
.comp__location {
  display: flex;
  align-items: center;
  justify-content: space-between;
  padding: 15px 0;
  box-shadow: inset 0px -1px 0px #EAF5FA;

  .icon {
    margin-right: 6px;
    color: $color-blue-smalt;
  }
}
.comp__location-action {
  display: flex;
  align-items: center;
  cursor: pointer;
  
  .icon {
    font-size: 10px;
    color: $color-grey-span;
  }
}
.comp__locations-edit {
  width: 100%;
  padding: 15px 0 25px 36px;
  color: $color-blue-smalt;

  .icon {
    color: $color-grey-span;
  }

  span {
    cursor: pointer;
  }
}

.comp-form__block {
  & + & {
    margin-top: 20px;
  }
}

.comp-form__block-title {
  margin-bottom: 10px;
  @include font-mixin(20px, 28px, 700, $color-text-base);
}

.comp-form__row {
  & + & {
    margin-top: 7px;
  }
}

.direction-to-delete,
.location-to-delete {
  display: flex;
  align-items: center;

  .icon {
    margin: 0 5px;
    color: $color-blue-smalt;
  }

  svg {
    margin-left: 5px;
  }
}
</style>